import {FormSchema} from "@/components/Form";

/**源端配置-中间树-表头列表*/
export const tableTreeData = [
  {
    title: 'bm_datasource',
    key: '0',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, catalog_id FROM bm_datasource',
  },
  {
    title: 'user_info',
    key: '1',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, catalog_id, name, description FROM user_info',
  },
  {
    title: 'customer_details',
    key: '2',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, user_id, username, email FROM customer_details',
  },
  {
    title: 'order_history',
    key: '3',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, order_id, total_amount FROM order_history',
  },
  {
    title: 'product_inventory',
    key: '4',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, product_id, product_name, price FROM product_inventory',
  },
  {
    title: 'transaction_logs',
    key: '5',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, category_id, category_name FROM transaction_logs',
  },
  {
    title: 'employee_records',
    key: '6',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, customer_id, customer_name FROM employee_records',
  },
  {
    title: 'payment_details',
    key: '7',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, customer_id, order_date FROM payment_details',
  },
  {
    title: 'shipping_addresses',
    key: '8',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, product_id, stock_quantity, last_updated FROM shipping_addresses',
  },
  {
    title: 'invoice_data',
    key: '9',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, user_id, address, phone_number FROM invoice_data',
  },
  {
    title: 'customer_feedback',
    key: '10',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, category_id, category_description, parent_category_id FROM customer_feedback',
  },
  {
    title: 'supplier_info',
    key: '11',
    icon: 'majesticons:table-line',
    sql: 'SELECT * FROM supplier_info', // 假设 supplier_info 表没有在 isCustomSQLTableList 中定义字段
  },
];

/**源端配置-右列表*/
export const notCustomSQLTableList = [
  // bm_datasource
  {
    businessId: '1',
    ownershipTableId: '0',
    fieldName: 'uuid',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '2',
    ownershipTableId: '0',
    fieldName: 'catalog_id',
    fieldType: 'BIGINT(19,0)',
  },

  // user_info
  {
    businessId: '3',
    ownershipTableId: '1',
    fieldName: 'user_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '4',
    ownershipTableId: '1',
    fieldName: 'username',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '5',
    ownershipTableId: '1',
    fieldName: 'email',
    fieldType: 'VARCHAR(100,0)',
  },

  // customer_details
  {
    businessId: '6',
    ownershipTableId: '2',
    fieldName: 'customer_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '7',
    ownershipTableId: '2',
    fieldName: 'first_name',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '8',
    ownershipTableId: '2',
    fieldName: 'last_name',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '9',
    ownershipTableId: '2',
    fieldName: 'address',
    fieldType: 'VARCHAR(255,0)',
  },

  // order_history
  {
    businessId: '10',
    ownershipTableId: '3',
    fieldName: 'order_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '11',
    ownershipTableId: '3',
    fieldName: 'customer_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '12',
    ownershipTableId: '3',
    fieldName: 'order_date',
    fieldType: 'DATETIME',
  },

  // product_inventory
  {
    businessId: '13',
    ownershipTableId: '4',
    fieldName: 'product_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '14',
    ownershipTableId: '4',
    fieldName: 'quantity',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '15',
    ownershipTableId: '4',
    fieldName: 'price',
    fieldType: 'DECIMAL(10,2)',
  },

  // transaction_logs
  {
    businessId: '16',
    ownershipTableId: '5',
    fieldName: 'log_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '17',
    ownershipTableId: '5',
    fieldName: 'transaction_type',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '18',
    ownershipTableId: '5',
    fieldName: 'amount',
    fieldType: 'DECIMAL(10,2)',
  },

  // employee_records
  {
    businessId: '19',
    ownershipTableId: '6',
    fieldName: 'employee_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '20',
    ownershipTableId: '6',
    fieldName: 'name',
    fieldType: 'VARCHAR(100,0)',
  },
  {
    businessId: '21',
    ownershipTableId: '6',
    fieldName: 'position',
    fieldType: 'VARCHAR(100,0)',
  },

  // payment_details
  {
    businessId: '22',
    ownershipTableId: '7',
    fieldName: 'payment_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '23',
    ownershipTableId: '7',
    fieldName: 'payment_method',
    fieldType: 'VARCHAR(50,0)',
  },
  {
    businessId: '24',
    ownershipTableId: '7',
    fieldName: 'amount',
    fieldType: 'DECIMAL(10,2)',
  },

  // shipping_addresses
  {
    businessId: '25',
    ownershipTableId: '8',
    fieldName: 'address_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '26',
    ownershipTableId: '8',
    fieldName: 'customer_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '27',
    ownershipTableId: '8',
    fieldName: 'address',
    fieldType: 'VARCHAR(255,0)',
  },

  // invoice_data
  {
    businessId: '28',
    ownershipTableId: '9',
    fieldName: 'invoice_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '29',
    ownershipTableId: '9',
    fieldName: 'invoice_date',
    fieldType: 'DATETIME',
  },
  {
    businessId: '30',
    ownershipTableId: '9',
    fieldName: 'total_amount',
    fieldType: 'DECIMAL(10,2)',
  },

  // customer_feedback
  {
    businessId: '31',
    ownershipTableId: '10',
    fieldName: 'feedback_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '32',
    ownershipTableId: '10',
    fieldName: 'customer_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '33',
    ownershipTableId: '10',
    fieldName: 'feedback_text',
    fieldType: 'TEXT',
  },

  // supplier_info
  {
    businessId: '34',
    ownershipTableId: '11',
    fieldName: 'supplier_id',
    fieldType: 'INT(11,0)',
  },
  {
    businessId: '35',
    ownershipTableId: '11',
    fieldName: 'company_name',
    fieldType: 'VARCHAR(100,0)',
  },
  {
    businessId: '36',
    ownershipTableId: '11',
    fieldName: 'contact_person',
    fieldType: 'VARCHAR(100,0)',
  },
];

/**源端配置-获取元数据按钮(弹窗)-列表*/
export const getMetadataTableList = [
  {
    tableName: 'bm_datasource',
    businessId: '0',
  },
  {
    tableName: 'user_info',
    businessId: '1',
  },
  {
    tableName: 'customer_details',
    businessId: '2',
  },
  {
    tableName: 'order_history',
    businessId: '3',
  },
  {
    tableName: 'product_inventory',
    businessId: '4',
  },
  {
    tableName: 'transaction_logs',
    businessId: '5',
  },
  {
    tableName: 'employee_records',
    businessId: '6',
  },
  {
    tableName: 'payment_details',
    businessId: '7',
  },
  {
    tableName: 'shipping_addresses',
    businessId: '8',
  },
  {
    tableName: 'invoice_data',
    businessId: '9',
  },
  {
    tableName: 'customer_feedback',
    businessId: '10',
  },
  {
    tableName: 'supplier_info',
    businessId: '11',
  },
];


/**映射规则配置-数据转换规则-列表数据 */
export const mappingRuleConfigurationTableList = [
  {
    businessId: '1',
    ruleType: '[全局] 新增字段规则1',
    ruleContent: '新增字段',
  },
  {
    businessId: '2',
    ruleType: '[全局] 字段名称映射规则1',
    ruleContent: '字段名称',
  },
  {
    businessId: '3',
    ruleType: '[全局] 字段类型映射规则1',
    ruleContent: '字段类型',
  },
  {
    businessId: '4',
    ruleType: '[全局] 表名映射规则1',
    ruleContent: '表名',
  },
];

/**映射规则配置-新增规则按钮-卡片规则列表 */
export const cardRuleList = [
  {
    title: '【全局】新增字段规则',
    type: 'newFieldRule',
    description: '为源端所有数据表都新增一个字段，例如为每张表增加一个入库时间列',
  },
  {
    title: '【全局】字段名称映射规则',
    type: 'fieldNameMappingRule',
    description: '通过正则表达式，将全局匹配的源端中的字段名称全部映射为输入的目标字段名称',
  },
  {
    title: '【全局】字段类型映射规则',
    type: 'fieldTypeMappingRule',
    description: '将全局匹配的源端中的字段类型全部映射为所选的目标字段类型',
  },

  {
    title: '【全局】表名映射规则',
    type: 'singleTableFieldMappingRule',
    description: '根据业务需求，对选中的源端表进行详情字段名、类型、注释 的映射配置',
  },
];
/**映射规则配置-字段名称映射规则-树形结构数据*/
export const fieldNameTableTreeData = [
  {
    title: 'table1_1',
    key: '1',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, catalog_id FROM bm_datasource',
  },
  {
    title: 'table1_2',
    key: '2',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, catalog_id, name, description FROM user_info',
  },
  {
    title: 'table1_3',
    key: '3',
    icon: 'majesticons:table-line',
    sql: 'SELECT uuid, user_id, username, email FROM customer_details',
  },
];
/**映射规则配置-字段名称映射规则-列表*/
export const fieldNameMappingRuleTableList = [
  {
    businessId: '1',
    ownershipTableId: '1',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '2',
    ownershipTableId: '1',
    fieldName: 'catalog_id',
    targetFieldName: 'test_catalog_id_obs',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '3',
    ownershipTableId: '1',
    fieldName: 'name',
    targetFieldName: 'test_name_obs',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '4',
    ownershipTableId: '1',
    fieldName: 'description',
    targetFieldName: 'test_description_obs',
    fieldType: 'TEXT',
  },
  {
    businessId: '5',
    ownershipTableId: '2',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs_2',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '6',
    ownershipTableId: '2',
    fieldName: 'user_id',
    targetFieldName: 'test_user_id_obs',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '7',
    ownershipTableId: '2',
    fieldName: 'username',
    targetFieldName: 'test_username_obs',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '8',
    ownershipTableId: '2',
    fieldName: 'email',
    targetFieldName: 'test_email_obs',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '9',
    ownershipTableId: '3',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs_3',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '10',
    ownershipTableId: '3',
    fieldName: 'order_id',
    targetFieldName: 'test_order_id_obs',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '11',
    ownershipTableId: '3',
    fieldName: 'total_amount',
    targetFieldName: 'test_total_amount_obs',
    fieldType: 'DECIMAL(10,2)',
  },
];

/**映射规则配置-新增规则按钮-源字段名称映射规则-列表*/
export const sourceFieldNameMappingRuleTableList = [
  {
    businessId: '1',
    ownershipTableId: '1',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '2',
    ownershipTableId: '1',
    fieldName: 'catalog_id',
    targetFieldName: 'test_catalog_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '3',
    ownershipTableId: '1',
    fieldName: 'name',
    targetFieldName: 'test_name_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '4',
    ownershipTableId: '1',
    fieldName: 'description',
    targetFieldName: 'test_description_obs',
    annotation: '-',
    fieldType: 'TEXT',
  },
  {
    businessId: '5',
    ownershipTableId: '2',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs_2',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '6',
    ownershipTableId: '2',
    fieldName: 'user_id',
    targetFieldName: 'test_user_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '7',
    ownershipTableId: '2',
    fieldName: 'username',
    targetFieldName: 'test_username_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '8',
    ownershipTableId: '2',
    fieldName: 'email',
    targetFieldName: 'test_email_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '9',
    ownershipTableId: '3',
    fieldName: 'uuid',
    targetFieldName: 'test_uuid_obs_3',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '10',
    ownershipTableId: '3',
    fieldName: 'order_id',
    targetFieldName: 'test_order_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '11',
    ownershipTableId: '3',
    fieldName: 'total_amount',
    targetFieldName: 'test_total_amount_obs',
    annotation: '-',
    fieldType: 'DECIMAL(10,2)',
  },
];
/**映射规则配置-新增规则按钮-目标字段名称映射规则-列表*/
export const goalFieldNameMappingRuleTableList = [
  {
    businessId: '1',
    ownershipTableId: '1',
    targetFieldName: 'test_uuid_obs',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '2',
    ownershipTableId: '1',
    targetFieldName: 'test_catalog_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '3',
    ownershipTableId: '1',
    targetFieldName: 'test_name_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '4',
    ownershipTableId: '1',
    targetFieldName: 'test_description_obs',
    annotation: '-',
    fieldType: 'TEXT',
  },
  {
    businessId: '5',
    ownershipTableId: '2',
    targetFieldName: 'test_uuid_obs_2',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '6',
    ownershipTableId: '2',
    targetFieldName: 'test_user_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '7',
    ownershipTableId: '2',
    targetFieldName: 'test_username_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '8',
    ownershipTableId: '2',
    targetFieldName: 'test_email_obs',
    annotation: '-',
    fieldType: 'VARCHAR(255)',
  },
  {
    businessId: '9',
    ownershipTableId: '3',
    targetFieldName: 'test_uuid_obs_3',
    annotation: '-',
    fieldType: 'VARCHAR(50)',
  },
  {
    businessId: '10',
    ownershipTableId: '3',
    targetFieldName: 'test_order_id_obs',
    annotation: '-',
    fieldType: 'BIGINT(19)',
  },
  {
    businessId: '11',
    ownershipTableId: '3',
    targetFieldName: 'test_total_amount_obs',
    annotation: '-',
    fieldType: 'DECIMAL(10,2)',
  },
];

/**映射规则配置-下拉框-字段类型*/
export const theTypeOfField = [
  {
    label: 'string',
    value: 'string',
  },
  {
    label: 'int',
    value: 'int',
  },
  {
    label: 'float',
    value: 'float',
  },
  {
    label: 'double',
    value: 'double',
  },
  {
    label: 'decimal',
    value: 'decimal',
  },
  {
    label: 'timestamp',
    value: 'timestamp',
  },
 ]
