import Mock, { Random } from 'mockjs';

// 自定义函数：生成在指定日期范围内的随机日期
function getRandomDate(start, end) {
  const startTime = new Date(start).getTime();
  const endTime = new Date(end).getTime();
  const randomTime = new Date(startTime + Math.random() * (endTime - startTime));
  return randomTime.toISOString().slice(0, 19).replace('T', ' '); // 格式化为 "yyyy-MM-dd HH:mm:ss"
}
const startDate = '2023-01-01 00:00:00'; // 起始日期
const endDate = '2024-12-31 23:59:59'; // 结束日期

export const fileData = (num) => {
  return Mock.mock({
    [`list|${num}`]: [
      // 根据 num 动态生成用户数量
      {
        'c1|+1': 1,
        'c2|18-60': 1,
        c3: '@cname',
        c4: '@pick(["男", "女"])',
        'c5|170-190': 1,
        c6: function () {
          return getRandomDate(startDate, endDate);
        },
        c7: function () {
          return getRandomDate(startDate, endDate);
        },
        c8: '@cname',
        c9: '@cname',
        c10: '@sentence(5, 10)',
      },
    ],
  }).list;
};
export const dataSourceData = [
  {
    businessId: 1,
    source: 'bm_datasource',
    target: 'bm_datasource',
    areaConfig: null,
    clearConfig: null,
  },
];
export const dataSourceFieldData = [
  {
    businessId: 1,
    sourceField: 'target field',
    targetField: 'target field',
    fieldRemark: null,
  },
  {
    businessId: 2,
    sourceField: 'source field',
    targetField: 'source field',
    fieldRemark: null,
  },
  {
    businessId: 3,
    sourceField: 'field comment',
    targetField: 'field comment',
    fieldRemark: null,
  },
];
export const cardRuleList = [
  {
    title: '【全局】新增字段规则',
    type: 'newFieldRule',
    description: '为源端所有数据表都新增一个字段，例如为每张表增加一个入库时间列',
  },
  {
    title: '数据转换规则',
    type: 'dataTransformationRule',
    description: '根据业务需求，对源端单张数据表的单个字段进行数据转换操作',
  },
  {
    title: '数据过滤规则',
    type: 'dataFilterRule',
    description: '根据业务需求，对源端单张数据表的数据进行过滤操作',
  },
];
export const mappingRuleConfigurationTableList = [
  {
    businessId: 1,
    ruleName: '[全局] 新增字段规则',
    ruleContent: '新增字段名称:a, 字段类型:string, 字段表达式:asd',
  },
  {
    businessId: 2,
    ruleName: '数据转换规则',
    ruleContent: '数据表: table1, 已有字段: field1, 转换规则: 配置规则',
  },
  {
    businessId: 3,
    ruleName: '数据过滤规则',
    ruleContent: "自定义规则:field1 != 'axxc'",
  },
];
